# Periodic Lyapunov equation solvers 

* **[`pclyap`](@ref)** Solution of periodic Lyapunov differential equations. 
* **[`prclyap`](@ref)** Solution of reverse-time periodic Lyapunov differential equation equations. 
* **[`pfclyap`](@ref)**  Solution of forward-time periodic Lyapunov differential equation equations.
* **[`pgclyap`](@ref)** Computation of periodic generators for periodic Lyapunov differential equations.
* **[`pgclyap2`](@ref)** Computation of periodic generators for a pair of periodic Lyapunov difference/differential and differential equations.
* **[`tvclyap_eval`](@ref)** Evaluation of time value of solution from the computed periodic generator.
* **[`pdlyap`](@ref)** Solution of periodic discrete-time Lyapunov equations. 
* **[`pdlyap2`](@ref)** Solution of a pair of periodic discrete-time Lyapunov equations. 
* **[`prdlyap`](@ref)** Solution of reverse-time periodic discrete-time Lyapunov equations. 
* **[`pfdlyap`](@ref)**  Solution of forward-time periodic discrete-time Lyapunov equations.
* **[`pcplyap`](@ref)** Solution of positve periodic Lyapunov differential equations. 
* **[`prcplyap`](@ref)** Solution of positve reverse-time periodic Lyapunov differential equations.
* **[`pfcplyap`](@ref)**  Solution of positve forward-time periodic Lyapunov differential equations.
* **[`pgcplyap`](@ref)** Computation of periodic generators for positive periodic Lyapunov differential equations.
* **[`tvcplyap_eval`](@ref)** Evaluation of time value of the upper triangular factor of solution from the computed periodic generator.
* **[`pdplyap`](@ref)** Solution of positve periodic discrete-time Lyapunov equations. 
* **[`prdplyap`](@ref)** Solution of positve reverse-time periodic discrete-time Lyapunov equations. 
* **[`pfdplyap`](@ref)**  Solution of positve forward-time periodic discrete-time Lyapunov equations.

```@docs
pclyap
prclyap
pfclyap
pgclyap
pgclyap2
tvclyap_eval
pdlyap
pdlyap2
prdlyap
pfdlyap
pcplyap
prcplyap
pfcplyap
pgcplyap
tvcplyap_eval
pdplyap
prdplyap
pfdplyap
```
