# Stabilization of periodic systems

**Periodic state feedback controller and estimator design** 
* **[`pclqr`](@ref)**  LQ-optimal state feedack stabilization of continuous-time periodic systems 
* **[`pclqry`](@ref)** LQ-optimal state feedack stabilization with output weighting of continuous-time periodic systems 
* **[`pdlqr`](@ref)**  LQ-optimal state feedack stabilization of discrete-time periodic systems 
* **[`pdlqry`](@ref)** LQ-optimal state feedack stabilization with output weighting of discrete-time periodic systems 
* **[`pckeg`](@ref)**  Kalman estimator gain matrix for continuous-time periodic systems 
* **[`pckegw`](@ref)**  Kalman estimator gain matrix for continuous-time periodic systems with noise inputs
* **[`pdkeg`](@ref)**  Kalman estimator gain matrix for periodic systems 
* **[`pdkegw`](@ref)**  Kalman estimator gain matrix for periodic systems with noise inputs


**Periodic output feedback controller design** 

* **[`pcpofstab_sw`](@ref)** Stabilization of continuous-time periodic systems using switching periodic output feedback.
* **[`pcpofstab_hr`](@ref)** Stabilization of continuous-time periodic systems using harmonic output feedback.
* **[`pdpofstab_sw`](@ref)** Stabilization of discrete-time periodic systems using switching periodic output feedback.
* **[`pdpofstab_hr`](@ref)** Stabilization of discrete-time periodic systems using discretized harmonic periodic output feedback.
* **[`pclqofc_sw`](@ref)** LQ-optimal stabilization of continuous-time periodic systems using switching periodic output feedback.
* **[`pclqofc_hr`](@ref)** LQ-optimal stabilization of continuous-time periodic systems using harmonic output feedback.
* **[`pdlqofc`](@ref)** LQ-optimal stabilization of discrete-time periodic systems using periodic output feedback.
* **[`pdlqofc_sw`](@ref)** LQ-optimal stabilization of discrete-time periodic systems using switching periodic output feedback.


```@docs
pclqr
pclqry
pdlqr
pdlqry
pckeg
pckegw
pdkeg
pdkegw
pcpofstab_sw
pcpofstab_hr
pdpofstab_sw
pdpofstab_hr
pclqofc_sw
pclqofc_hr
pdlqofc
pdlqofc_sw
```
