# Periodic system utilities

* **[`pseig`](@ref)**   Characteristic multipliers of a periodic matrix.
* **[`psceig`](@ref)**   Characteristic exponents of a periodic matrix.
* **[`psceighr`](@ref)**   Characteristic exponents of a periodic matrix in Harmonic Array representation.
* **[`psceigfr`](@ref)**   Characteristic exponents of a periodic matrix in Fourier Function Matrix representation.
* **[`monodromy`](@ref)**  Monodromy matrix of a linear periodic time-varying system of ODE.
* **[`tvstm`](@ref)**  State transition matrix of a linear time-varying system of ODE.
* **[`psreduc_reg`](@ref)**  Fast reduction of a lifted regular pencil corresponding to a product of matrices. 
* **[`tvmeval`](@ref)**  Time response evaluation of a continuous-time periodic matrix. 
* **[`hreval`](@ref)**  Evaluation of a harmonic array for a numerical or symbolic time value. 
* **[`hrchop`](@ref)**  Removal of the negligible trailing terms of a harmonic representation. 
* **[`hrtrunc`](@ref)**  Truncation of a harmonic representation.  
* **[`pmaverage`](@ref)**  Evaluation of the time averaged matrix of a continuous-time periodic matrix. 
* **[`pslyapd`](@ref)**  Solution of periodic discrete-time Lyapunov equations using periodic Schur decomposition. 
* **[`pslyapd2`](@ref)**  Solution of a pair periodic discrete-time Lyapunov equations using a single periodic Schur decomposition. 
* **[`pslyapdkr`](@ref)**  Solution of periodic discrete-time Lyapunov equations using Kronecker product expansions. 
* **[`psplyapd`](@ref)** Solution of positve periodic discrete-time Lyapunov equations. 


```@docs
pseig
psceig
psceighr
psceigfr
monodromy
tvstm
psreduc_reg
tvmeval
hreval
hrchop
hrtrunc
pmaverage
pslyapd
pslyapd2
pslyapdkr
psplyapd
```
